n = 5; % dimension

S = randn(n,n);
A = S*S'; % symmetric and positive defiend matrix


m = 3; % number of lanzcos vectors

Q = zeros(n,m+2);
Q(:,2) = randn(n,1);
Q(:,2) = Q(:,2)/norm(Q(:,2));  % Q(:,2) = random vector of norm 1

alpha = zeros(m,1);
beta = zeros(m+1,1);

for j=1:m
   r = A*Q(:,j+1) - beta(j)*Q(:,j);
   alpha(j) = r'*Q(:,j+1);
   r = r - alpha(j)*Q(:,j+1);
    
   beta(j+1) = norm(r);
   Q(:,j+2) = r/beta(j+1);
end    

Q = Q(:,2:end-1);
beta = beta(1:end-1);

% tidiagonal matrix
T = diag(alpha) + diag(beta(2:end),1) + diag(beta(2:end),-1);

d = Q'*A*Q - T;  % should be close to zero


