% Example for reading a netcdf file
% in Matlab and Octave

% the name of the netcdf file
filename = 'example.nc';

% retrieve the netcdf variable temp
temp = ncread(filename,'temp');

% retrieve the attribute units of variable temp
temp_units = ncreadatt(filename,'temp','units');

% retrieve the attribute valid_range of variable temp
temp_valid_range = ncreadatt(filename,'temp','valid_range');

% retrieve the global attribute history
global_history = ncreadatt(filename,'/','history');
